Template Numerical Library: TNL::Matrices::LambdaMatrixElement< Real, Index > Class Template Reference

Template Numerical Library version\ main:16b9213d5

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Protected Attributes | List of all members
TNL::Matrices::LambdaMatrixElement< Real, Index > Class Template Reference

Accessor for elements of lambda matrix. More...

`#include <TNL/Matrices/LambdaMatrixElement.h>`

## Public Types
using | IndexType = Index
| Type of matrix elements column indexes.
using | RealType = Real
| Type of matrix elements values.

## Public Member Functions
__cuda_callable__ | LambdaMatrixElement (const LambdaMatrixElement &el)=default
| Copy constructor.
__cuda_callable__ | LambdaMatrixElement (const RealType &value, const IndexType &rowIdx, const IndexType &columnIdx, const IndexType &localIdx)
| Constructor.
__cuda_callable__ const IndexType & | columnIndex () const
| Returns constant reference on matrix element column index.
__cuda_callable__ const IndexType & | localIndex () const
| Returns constant reference on the rank of the non-zero matrix element in the row.
__cuda_callable__ const IndexType & | rowIndex () const
| Returns constant reference on matrix element row index.
__cuda_callable__ const RealType & | value () const
| Returns constant reference on matrix element value.

## Protected Attributes
const IndexType | columnIdx
const IndexType & | localIdx
const IndexType & | rowIdx
const RealType | value_

## Detailed Description

template<typename Real, typename Index>
class TNL::Matrices::LambdaMatrixElement< Real, Index >

Accessor for elements of lambda matrix.

Template Parameters

  Real | is type of matrix elements values.
  Index | is a type of matrix elements column indexes.

## Constructor & Destructor Documentation

## ◆ LambdaMatrixElement() [1/2]

template<typename Real, typename Index>

__cuda_callable__ TNL::Matrices::LambdaMatrixElement< Real, Index >::LambdaMatrixElement | ( | const RealType & | value,
|  | const IndexType & | rowIdx,
|  | const IndexType & | columnIdx,
|  | const IndexType & | localIdx )
| inline

Constructor.

Parameters

  value | is matrix element value.
  rowIdx | is row index of the matrix element.
  columnIdx | is a column index of the matrix element.
  localIdx | is the rank of the non-zero elements in the matrix row.

## ◆ LambdaMatrixElement() [2/2]

template<typename Real, typename Index>

__cuda_callable__ TNL::Matrices::LambdaMatrixElement< Real, Index >::LambdaMatrixElement | ( | const LambdaMatrixElement< Real, Index > & | el | ) |
| default

Copy constructor.

Parameters

  el | is the source matrix element.

## Member Function Documentation

## ◆ columnIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::LambdaMatrixElement< Real, Index >::columnIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element column index.

Returns
  constant reference on matrix element column index.

## ◆ localIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::LambdaMatrixElement< Real, Index >::localIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on the rank of the non-zero matrix element in the row.

Returns
  constant reference on the rank of the non-zero matrix element in the row.

## ◆ rowIndex()

template<typename Real, typename Index>

__cuda_callable__ const IndexType & TNL::Matrices::LambdaMatrixElement< Real, Index >::rowIndex | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element row index.

Returns
  constant reference on matrix element row index.

## ◆ value()

template<typename Real, typename Index>

__cuda_callable__ const RealType & TNL::Matrices::LambdaMatrixElement< Real, Index >::value | ( |  | ) | const
| inlinenodiscard

Returns constant reference on matrix element value.

Returns
  constant reference on matrix element value.

The documentation for this class was generated from the following file:

- src/TNL/Matrices/LambdaMatrixElement.h